/* The following code was generated by JFlex 1.4.1 on 15/05/08 13:13 */

/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Scanner.java
 * Copyright (C) 2008 University of Waikato, Hamilton, New Zealand
 */

package weka.filters.unsupervised.instance.subsetbyexpression;

import weka.core.parser.java_cup.runtime.SymbolFactory;
import java.io.*;

/**
 * A scanner for evaluating whether an Instance is to be included in a subset
 * or not.
 *
 * @author FracPete (fracpete at waikato dot ac dot nz)
 * @version $Revision: 1.1 $
 */

public class Scanner implements weka.core.parser.java_cup.runtime.Scanner {

  /** This character denotes the end of file */
  public static final int YYEOF = -1;

  /** initial size of the lookahead buffer */
  private static final int ZZ_BUFFERSIZE = 16384;

  /** lexical states */
  public static final int YYINITIAL = 0;

  /** 
   * Translates characters to character classes
   */
  private static final char [] ZZ_CMAP = {
     0,  0,  0,  0,  0,  0,  0,  0,  0, 35, 35,  0, 35, 35,  0,  0, 
     0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 
    35,  0,  0,  0,  0,  0,  0, 34, 37, 38,  3,  2, 36,  1, 28,  4, 
    27, 27, 27, 27, 27, 27, 27, 27, 27, 27,  0,  0,  5,  6,  7,  0, 
     0, 29,  0, 31,  0,  0,  0,  0,  0,  0,  0,  0, 32,  0,  0,  0, 
     0,  0,  0, 33, 30,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 
     0, 13, 20, 25, 14, 17, 18, 22,  0,  8,  0,  0, 19, 39, 10, 11, 
    24, 21, 15,  9, 12, 16,  0, 26, 23,  0,  0,  0,  0,  0,  0,  0
  };

  /** 
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7"+
    "\1\10\14\1\1\11\3\1\1\12\1\13\1\14\1\15"+
    "\1\16\1\17\1\20\3\0\1\21\14\0\1\11\3\0"+
    "\1\22\1\0\1\23\1\0\1\24\1\25\1\0\1\26"+
    "\1\27\1\0\1\30\2\0\1\31\1\32\1\33\4\0"+
    "\1\34\1\35\1\36\2\0\1\37\1\40\2\0\1\41"+
    "\1\42\1\43\3\0\1\44";

  private static int [] zzUnpackAction() {
    int [] result = new int[88];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** 
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\50\0\120\0\50\0\50\0\50\0\170\0\50"+
    "\0\240\0\310\0\360\0\u0118\0\u0140\0\u0168\0\u0190\0\u01b8"+
    "\0\u01e0\0\u0208\0\u0230\0\u0258\0\u0280\0\u02a8\0\u02d0\0\u02f8"+
    "\0\u0320\0\50\0\50\0\50\0\50\0\50\0\50\0\u0348"+
    "\0\u0370\0\u0398\0\u03c0\0\50\0\u03e8\0\u0410\0\u0438\0\u0460"+
    "\0\u0488\0\u04b0\0\u04d8\0\u0500\0\u0528\0\u0550\0\u0578\0\u05a0"+
    "\0\u05c8\0\u05f0\0\u0618\0\u0320\0\50\0\u0640\0\50\0\u0668"+
    "\0\50\0\50\0\u0690\0\50\0\50\0\u06b8\0\50\0\u06e0"+
    "\0\u0708\0\50\0\50\0\50\0\u0730\0\u0758\0\u0780\0\u07a8"+
    "\0\50\0\50\0\50\0\u07d0\0\u07f8\0\50\0\u0758\0\u0820"+
    "\0\u0848\0\50\0\50\0\50\0\u0870\0\u0898\0\u08c0\0\50";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[88];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /** 
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11"+
    "\1\12\1\13\1\14\1\15\1\16\1\17\1\2\1\20"+
    "\1\2\1\21\1\22\1\23\4\2\1\24\1\25\1\2"+
    "\1\26\1\2\1\27\1\2\1\30\2\2\1\31\1\32"+
    "\1\33\1\34\1\35\1\2\103\0\1\26\22\0\1\36"+
    "\47\0\1\37\52\0\1\40\46\0\1\41\14\0\1\42"+
    "\35\0\1\43\53\0\1\44\45\0\1\45\1\0\1\46"+
    "\42\0\1\47\11\0\1\50\33\0\1\51\66\0\1\52"+
    "\35\0\1\53\5\0\1\54\37\0\1\55\47\0\1\56"+
    "\47\0\1\57\5\0\1\60\61\0\1\26\1\61\51\0"+
    "\1\62\51\0\1\63\7\0\34\64\1\0\5\64\1\65"+
    "\5\64\47\0\1\66\12\0\1\67\54\0\1\70\44\0"+
    "\1\71\45\0\1\72\55\0\1\73\45\0\1\74\42\0"+
    "\1\75\50\0\1\76\65\0\1\77\42\0\1\100\37\0"+
    "\1\101\62\0\1\102\53\0\1\103\26\0\1\104\46\0"+
    "\1\105\72\0\1\61\52\0\1\106\46\0\1\107\22\0"+
    "\1\110\53\0\1\111\54\0\1\112\42\0\1\113\44\0"+
    "\1\114\51\0\1\115\57\0\1\116\57\0\1\117\55\0"+
    "\1\120\17\0\1\121\57\0\1\122\45\0\1\123\71\0"+
    "\1\124\17\0\1\125\46\0\1\126\51\0\1\127\63\0"+
    "\1\130\21\0";

  private static int [] zzUnpackTrans() {
    int [] result = new int[2280];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /* error codes */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  private static final int ZZ_NO_MATCH = 1;
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /* error messages for the codes above */
  private static final String ZZ_ERROR_MSG[] = {
    "Unkown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state <code>aState</code>
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\0\1\11\1\1\3\11\1\1\1\11\21\1\6\11"+
    "\1\1\3\0\1\11\14\0\1\1\3\0\1\11\1\0"+
    "\1\11\1\0\2\11\1\0\2\11\1\0\1\11\2\0"+
    "\3\11\4\0\3\11\2\0\1\11\1\1\2\0\3\11"+
    "\3\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[88];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** the input device */
  private java.io.Reader zzReader;

  /** the current state of the DFA */
  private int zzState;

  /** the current lexical state */
  private int zzLexicalState = YYINITIAL;

  /** this buffer contains the current text to be matched and is
      the source of the yytext() string */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** the textposition at the last accepting state */
  private int zzMarkedPos;

  /** the textposition at the last state to be included in yytext */
  private int zzPushbackPos;

  /** the current text position in the buffer */
  private int zzCurrentPos;

  /** startRead marks the beginning of the yytext() string in the buffer */
  private int zzStartRead;

  /** endRead marks the last character in the buffer, that has been read
      from input */
  private int zzEndRead;

  /** number of newlines encountered up to the start of the matched text */
  private int yyline;

  /** the number of characters up to the start of the matched text */
  private int yychar;

  /**
   * the number of characters from the last newline up to the start of the 
   * matched text
   */
  private int yycolumn;

  /** 
   * zzAtBOL == true <=> the scanner is currently at the beginning of a line
   */
  private boolean zzAtBOL = true;

  /** zzAtEOF == true <=> the scanner is at the EOF */
  private boolean zzAtEOF;

  /* user code: */
  // Author: FracPete (fracpete at waikato dot ac dot nz)
  // Version: $Revision: 1.1 $
  protected SymbolFactory sf;

  public Scanner(InputStream r, SymbolFactory sf){
    this(r);
    this.sf = sf;
  }


  /**
   * Creates a new scanner
   * There is also a java.io.InputStream version of this constructor.
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public Scanner(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Creates a new scanner.
   * There is also java.io.Reader version of this constructor.
   *
   * @param   in  the java.io.Inputstream to read input from.
   */
  public Scanner(java.io.InputStream in) {
    this(new java.io.InputStreamReader(in));
  }


  /**
   * Refills the input buffer.
   *
   * @return      <code>false</code>, iff there was new input.
   * 
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead-zzStartRead);

      /* translate stored positions */
      zzEndRead-= zzStartRead;
      zzCurrentPos-= zzStartRead;
      zzMarkedPos-= zzStartRead;
      zzPushbackPos-= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzCurrentPos*2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
    }

    /* finally: fill the buffer with new input */
    int numRead = zzReader.read(zzBuffer, zzEndRead,
                                            zzBuffer.length-zzEndRead);

    if (numRead < 0) {
      return true;
    }
    else {
      zzEndRead+= numRead;
      return false;
    }
  }

    
  /**
   * Closes the input stream.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true;            /* indicate end of file */
    zzEndRead = zzStartRead;  /* invalidate buffer    */

    if (zzReader != null)
      zzReader.close();
  }


  /**
   * Resets the scanner to read from a new input stream.
   * Does not close the old reader.
   *
   * All internal variables are reset, the old input stream 
   * <b>cannot</b> be reused (internal buffer is discarded and lost).
   * Lexical state is set to <tt>ZZ_INITIAL</tt>.
   *
   * @param reader   the new input stream 
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzAtBOL  = true;
    zzAtEOF  = false;
    zzEndRead = zzStartRead = 0;
    zzCurrentPos = zzMarkedPos = zzPushbackPos = 0;
    yyline = yychar = yycolumn = 0;
    zzLexicalState = YYINITIAL;
  }


  /**
   * Returns the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   */
  public final String yytext() {
    return new String( zzBuffer, zzStartRead, zzMarkedPos-zzStartRead );
  }


  /**
   * Returns the character at position <tt>pos</tt> from the 
   * matched text. 
   * 
   * It is equivalent to yytext().charAt(pos), but faster
   *
   * @param pos the position of the character to fetch. 
   *            A value from 0 to yylength()-1.
   *
   * @return the character at position pos
   */
  public final char yycharat(int pos) {
    return zzBuffer[zzStartRead+pos];
  }


  /**
   * Returns the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occured while scanning.
   *
   * In a wellformed scanner (no or only correct usage of 
   * yypushback(int) and a match-all fallback rule) this method 
   * will only be called with things that "Can't Possibly Happen".
   * If this method is called, something is seriously wrong
   * (e.g. a JFlex bug producing a faulty scanner etc.).
   *
   * Usual syntax/scanner level error handling should be done
   * in error fallback rules.
   *
   * @param   errorCode  the code of the errormessage to display
   */
  private void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    }
    catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  } 


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * They will be read again by then next call of the scanning method
   *
   * @param number  the number of characters to be read again.
   *                This number must not be greater than yylength()!
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


  /**
   * Resumes scanning until the next regular expression is matched,
   * the end of input is encountered or an I/O-Error occurs.
   *
   * @return      the next token
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  public weka.core.parser.java_cup.runtime.Symbol next_token() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char [] zzBufferL = zzBuffer;
    char [] zzCMapL = ZZ_CMAP;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;
  
      zzState = zzLexicalState;


      zzForAction: {
        while (true) {
    
          if (zzCurrentPosL < zzEndReadL)
            zzInput = zzBufferL[zzCurrentPosL++];
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = zzBufferL[zzCurrentPosL++];
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMapL[zzInput] ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          int zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
        case 32: 
          { return sf.newSymbol("Attribute", sym.ATTRIBUTE, new String(yytext()));
          }
        case 37: break;
        case 23: 
          { return sf.newSymbol("Abs", sym.ABS);
          }
        case 38: break;
        case 19: 
          { return sf.newSymbol("Sin", sym.SIN);
          }
        case 39: break;
        case 10: 
          { /* ignore white space. */
          }
        case 40: break;
        case 11: 
          { return sf.newSymbol("Comma", sym.COMMA);
          }
        case 41: break;
        case 18: 
          { return sf.newSymbol("String", sym.STRING, new String(yytext().substring(1, yytext().length() - 1)));
          }
        case 42: break;
        case 4: 
          { return sf.newSymbol("Times", sym.TIMES);
          }
        case 43: break;
        case 35: 
          { return sf.newSymbol("Class", sym.ATTRIBUTE, new String(yytext()));
          }
        case 44: break;
        case 34: 
          { return sf.newSymbol("Floor", sym.FLOOR);
          }
        case 45: break;
        case 33: 
          { return sf.newSymbol("False", sym.FALSE);
          }
        case 46: break;
        case 9: 
          { return sf.newSymbol("Number", sym.NUMBER, new Double(yytext()));
          }
        case 47: break;
        case 26: 
          { return sf.newSymbol("Pow", sym.POW);
          }
        case 48: break;
        case 6: 
          { return sf.newSymbol("Less than", sym.LT);
          }
        case 49: break;
        case 31: 
          { return sf.newSymbol("Ceil", sym.CEIL);
          }
        case 50: break;
        case 13: 
          { return sf.newSymbol("Right Bracket", sym.RPAREN);
          }
        case 51: break;
        case 21: 
          { return sf.newSymbol("Tan", sym.TAN);
          }
        case 52: break;
        case 29: 
          { return sf.newSymbol("True", sym.TRUE);
          }
        case 53: break;
        case 7: 
          { return sf.newSymbol("Equals", sym.EQ);
          }
        case 54: break;
        case 15: 
          { return sf.newSymbol("Greater or equal than", sym.GE);
          }
        case 55: break;
        case 27: 
          { return sf.newSymbol("Cos", sym.COS);
          }
        case 56: break;
        case 28: 
          { return sf.newSymbol("Sqrt", sym.SQRT);
          }
        case 57: break;
        case 25: 
          { return sf.newSymbol("Log", sym.LOG);
          }
        case 58: break;
        case 16: 
          { return sf.newSymbol("Is", sym.IS);
          }
        case 59: break;
        case 2: 
          { return sf.newSymbol("Minus", sym.MINUS);
          }
        case 60: break;
        case 3: 
          { return sf.newSymbol("Plus", sym.PLUS);
          }
        case 61: break;
        case 30: 
          { return sf.newSymbol("Rint", sym.RINT);
          }
        case 62: break;
        case 14: 
          { return sf.newSymbol("Less or equal than", sym.LE);
          }
        case 63: break;
        case 12: 
          { return sf.newSymbol("Left Bracket", sym.LPAREN);
          }
        case 64: break;
        case 24: 
          { return sf.newSymbol("Exp", sym.EXP);
          }
        case 65: break;
        case 5: 
          { return sf.newSymbol("Division", sym.DIVISION);
          }
        case 66: break;
        case 1: 
          { System.err.println("Illegal character: "+yytext());
          }
        case 67: break;
        case 20: 
          { return sf.newSymbol("Not", sym.NOT);
          }
        case 68: break;
        case 36: 
          { return sf.newSymbol("Missing", sym.ISMISSING);
          }
        case 69: break;
        case 17: 
          { return sf.newSymbol("Or", sym.OR);
          }
        case 70: break;
        case 8: 
          { return sf.newSymbol("Greater than", sym.GT);
          }
        case 71: break;
        case 22: 
          { return sf.newSymbol("And", sym.AND);
          }
        case 72: break;
        default: 
          if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
            zzAtEOF = true;
              {     return sf.newSymbol("EOF",sym.EOF);
 }
          } 
          else {
            zzScanError(ZZ_NO_MATCH);
          }
      }
    }
  }


}
